#include <LiquidCrystal_I2C.h>
#define button 2
#define buzzer 3
LiquidCrystal_I2C lcd(0x3F, 16, 2);

long total_time = 0, study_time, break_time;
long previous_time = 0, current_time, tmp;
String print_time;
bool flag = true;

void lcd_display(String words, long* time, int dt) {
    print_time = "";
    tmp = *time;
    print_time += (String)(tmp/3600) + ":";
    tmp %= 3600;
    print_time += (String)(tmp/60) + ":";
    tmp %= 60;
    print_time += (String)tmp;
    
    current_time = millis();
    if(current_time-previous_time >= 1000) {
	lcd.clear();
	lcd.setCursor(0, 0);
	lcd.print(words);
	lcd.setCursor(0, 1);
	lcd.print(print_time);
	previous_time = millis();
	*time += dt;
    }
}

void notify() {
    analogWrite(buzzer, 100);
    delay(500);
    analogWrite(buzzer, 0);
    delay(500);
    analogWrite(buzzer, 100);
    delay(500);
    analogWrite(buzzer, 0);
}

void setup() {
    pinMode(button, INPUT);
    pinMode(buzzer, OUTPUT);
    lcd.init();
    lcd.backlight();
    lcd.clear();
}

void loop() {
    lcd_display("Total Time", &total_time, 0);
    if(digitalRead(button) == 1) {
	while(digitalRead(button) == 1) {}
	study_time = 0;
	while(digitalRead(button) == 0) {
	    if(flag) lcd_display("Focusing...", &study_time, 1);
	    else {
		lcd_display("Taking a Break...", &break_time, -1);
		if(break_time <= 0) {
		    notify();
		    break;
		}
	    }
	}
	while(digitalRead(button) == 1) {}
	break_time = study_time / 5;
	total_time += study_time;
	flag = !flag;
    }
}
